script "motifs.pl";

# honeycomb triangulation #12369387
my $H=new IncidenceMatrix([[0,1,4,10],[10,11,13,16],[16,17,18,19],[2,3,6,12],[11,12,14,17],[1,2,5,11],[11,16,17,18],[2,11,12,14],[5,6,8,14],[7,8,9,15],[13,14,15,18],[2,6,12,14],[11,14,17,18],[2,5,11,14],[11,13,16,18],[1,10,11,13],[5,8,14,15],[5,7,8,15],[11,13,14,18],[5,13,14,15],[2,5,6,14],[1,5,11,13],[1,4,10,13],[4,5,7,13],[5,7,13,15],[1,4,5,13],[5,11,13,14]]);

my $dsdH = all_motifs($H);
my $stored_dsdH = load('honeycomb');

# triangulation from Hampe-Joswig #5054117
my $motif3J = new IncidenceMatrix([[0,1,4,10],[11,12,14,17],[1,2,5,11],[11,14,15,17],[2,5,9,11],[2,6,8,14],[2,3,6,14],[11,17,18,19],[2,8,9,14],[11,15,17,18],[1,5,9,11],[1,4,7,13],[3,11,12,14],[2,3,11,14],[2,11,14,15],[2,9,14,15],[2,9,11,15],[1,7,9,15],[1,9,11,15],[1,11,18,19],[1,4,10,16],[1,7,13,18],[1,7,15,18],[1,11,15,18],[1,4,16,19],[1,4,13,19],[1,13,18,19]]);

my $dsd_motif3J = all_motifs($motif3J);
my $stored_dsd_motif3J = load('motif3J');

# triangulation with 3E motif missing (where A=G) #54950
my $motif3E_AG = new IncidenceMatrix([[0,1,5,13],[0,1,12,13],[0,4,5,13],[0,10,11,13],[0,11,12,13],[1,2,5,13],[1,2,12,13],[2,3,6,13],[2,3,12,13],[2,5,9,13],[2,6,8,13],[2,8,9,13],[3,6,12,13],[4,5,7,13],[5,7,9,13],[6,8,12,13],[8,9,13,14],[8,12,13,14],[9,13,14,17],[9,13,16,17],[9,15,16,17],[10,11,13,16],[11,12,13,17],[11,13,16,17],[12,13,14,17],[15,16,17,18],[16,17,18,19]]);

my $dsd_motif3E_AG = all_motifs($motif3E_AG);
my $stored_dsd_motif3E_AG = load('motif3E_AG');

# triangulation with 3E motif missing (where A=F) #122773
my $motif3E_AF = new IncidenceMatrix([[0,1,5,11],[0,4,5,11],[0,4,11,13],[0,10,13,17],[0,11,13,17],[1,2,5,11],[2,3,6,12],[2,5,8,11],[2,6,8,12],[2,8,11,14],[2,8,12,14],[2,11,14,17],[2,12,14,17],[4,5,8,11],[4,7,8,11],[4,7,11,13],[7,8,9,11],[7,9,11,13],[8,9,11,14],[9,11,13,15],[9,11,14,15],[10,13,16,17],[11,13,15,17],[11,14,15,17],[13,15,16,17],[15,16,17,18],[16,17,18,19]]);

my $dsd_motif3E_AF = all_motifs($motif3E_AF);
my $stored_dsd_motif3E_AF = load('motif3E_AF');

compare_values('honeycomb:N_MOTIF_TYPES', $stored_dsdH->N_MOTIF_TYPES, $dsdH->N_MOTIF_TYPES);
compare_values('honeycomb:N_ALL_MOTIFS', $stored_dsdH->N_ALL_MOTIFS, $dsdH->N_ALL_MOTIFS);
compare_values('honeycomb:B_VECTOR', $stored_dsdH->B_VECTOR, $dsdH->B_VECTOR);
compare_values('motif3J:N_MOTIF_TYPES', $stored_dsd_motif3J->N_MOTIF_TYPES, $dsd_motif3J->N_MOTIF_TYPES);
compare_values('motif3J:N_ALL_MOTIFS', $stored_dsd_motif3J->N_ALL_MOTIFS, $dsd_motif3J->N_ALL_MOTIFS);
compare_values('motif3J:B_VECTOR', $stored_dsd_motif3J->B_VECTOR, $dsd_motif3J->B_VECTOR);
compare_values('motif3E_AG:N_MOTIF_TYPES', $stored_dsd_motif3E_AG->N_MOTIF_TYPES, $dsd_motif3E_AG->N_MOTIF_TYPES);
compare_values('motif3E_AG:N_ALL_MOTIFS', $stored_dsd_motif3E_AG->N_ALL_MOTIFS, $dsd_motif3E_AG->N_ALL_MOTIFS);
compare_values('motif3E_AG:B_VECTOR', $stored_dsd_motif3E_AG->B_VECTOR, $dsd_motif3E_AG->B_VECTOR);
compare_values('motif3E_AF:N_MOTIF_TYPES', $stored_dsd_motif3E_AF->N_MOTIF_TYPES, $dsd_motif3E_AF->N_MOTIF_TYPES);
compare_values('motif3E_AF:N_ALL_MOTIFS', $stored_dsd_motif3E_AF->N_ALL_MOTIFS, $dsd_motif3E_AF->N_ALL_MOTIFS);
compare_values('motif3E_AF:B_VECTOR', $stored_dsd_motif3E_AF->B_VECTOR, $dsd_motif3E_AF->B_VECTOR);
